/* xahfile.h                     freeware                  xhunga@tiscali.fr  */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

#include "xbdefine.h"
#include "xbstruct.h"
#include "xbprintm.h"  /* printmF                                             */
#include "xbfract1.h"  /* fminiFnotZero,                                      */

/*
Determinant
Inverse
GaussJordan
*/
#include "xcfrwmni.h"  /* fminiF,  frowminiF,                                 */
#include "xcelrop1.h"  /* swaprowF, mulrowF                                   */
#include "xcpivot1.h"  /* pivotntzeroF, pivotminiF, pivotworkF                */
#include "xcgauss.h"   /* growminiF, gausspivotbestF, gaussF, gaussjordanF,   */
#include "xcmatop1.h"  /* transposeF,                                         */
#include "xcdet1.h"    /* detF                                                */
#include "xcdet2.h"    /* minorF                                              */
#include "xcdet3.h"    /* cofactorF, mcofactorF, adjointF, inverseF           */

/*
Elementary operations
*/
#include "xdelrop2.h"   /* addrowF, addrowautoF,                              */

/*
+,-,*,trace,
*/
#include "xefract2.h"  /* addF,                                               */
#include "xcmatop2.h"  /* addmF, submF, multmF, smultmF,  traceF,             */
#include "xemid.h"     /* mid,                                                */
#include "xcmatop3.h"  /* powmF                                               */

/*
Control screen
*/
#include "xgscreen.h"  /* clrscrn                                             */

/*
Print
*/
#include "xhprtmn.h"   /* printmF(10,4,3,0),                                  */
#include "xhprtmi.h"   /* printmI(10,4,3,0),                                  */
#include "xhprtrow.h"  /* printrowF(10,4,3,0),                                */
#include "xhprtcol.h"  /* printcolF                                           */
#include "xhprtmif.h"  /* printmIF(10,4,3,0),                                 */
#include "xhprtmbf.h"  /* printmA_IDbF,                                       */
#include "xhprtmbi.h"  /* printmA_IDbI                                        */
#include "xhprintc.h"  /* printForCopyF(4,3,0),                               */
#include "xhprtmpl.h"  /* printmplF,                                          */

/*
Copy
*/
#include "xjcopym1.h"  /* copymF,                                             */
#include "xjcopym2.h"  /* copymAIDF, copyinvF                                 */
#include "xjcopyrc.h"  /* copyrowF, copycolF,                                 */

/*
Some Matrix
*/
#include "xkm01.h"     /* mzero,mone                                          */
#include "xkrand.h"    /* randF                                               */
#include "xkm.h"       /* randmF                                              */
#include "xkmdiag.h"   /* mdiagF ,mdiagI ,mdiag123F ,mdiag123I                */
#include "xkmtriag.h"  /* mlowertriangF, mlowertriangI,
                          muppertriangF, muppertriangI                        */
#include "xkmsymtr.h"  /* msymetricF, msymetricI                              */

/*
Fraction
*/
#include "xlfract3.h"   /* subF, multF, divF, invF,                           */

/*
 mtrxgo.zip :             Geometric application.
*/
#include "xnpoly.h"    /* mofpoly, resultis, calculate_y                      */
#include "xnconic.h"   /* mofconicA, mofconicE, mofcircle conicresultis,
                          calculate_conic, calculate_circle,                  */
/*
 mtrxid.zip :             Application of the identity matrix.
 mtrxic.zip :             Application of the identity matrix II.
*/
#include "xpid.h"      /* gjidF,  invidF,                                     */
#include "xpid2.h"     /* gjidF2, invidF2                                     */
#include "xppivot2.h"  /* pivotworkF                                          */
#include "xpid3.h"     /*   idF3,   idF3a,                                    */
#include "xpid4.h"     /*   idF4,   idF4a,                                    */

